/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hama.graph;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.io.Writable;

public class DxWasteNodeAggregator<V extends Writable, E extends Writable, M extends Writable> implements Aggregator<M, Vertex<V, E, M>> {
	private static final Log LOG = LogFactory.getLog(DxWasteMsgAggregator.class);
    double wasteNodeSum = 0;

    public void aggregate(Vertex<V, E, M> vertex, M value) {      
      if (vertex != null) {
    	  wasteNodeSum += ((DoubleWritable)value).get();
      } else {
    	  //LOG.info("Null vertex!");
      }
    }

    public M getValue() {
      return (M)(new DoubleWritable(wasteNodeSum));
    }
}
